---
title: "Get document history"
url: "https://docs.signnow.com/docs/document/operations/get-document-historyfull"
type: "endpoint"
section: "document"
slug: "document/operations/get-document-historyfull"
method: "GET"
path: "/document/{document_id}/historyfull"
operation_id: "get-document-historyfull"
authorization: "bearer"
---

# Get document history

`GET /document/{document_id}/historyfull`

Returns the history of a document.

For the events: 

* `signer_authentication_success` 
* `signer_authentication_failure` 

the response may contain an additional parameter `phone_number_2fa` which shows the signer's phone number used for authentication method `phone` or `sms`.

For the event: 

* `signer_authentication_success` 

the response may contain an additional parameter `authentication_code` which shows the code used for authentication method `sms`. The signer receives a code by SMS and enters this code to access the opened document.

## Authorization

bearer

## Path Parameters

| Name | Type | Required | Description |
|------|------|----------|-------------|
| `document_id` | string | Yes |  |

## Responses

### 200

Successfully get history of a document:
* without email history events
* with email history events.
* for the event `signer_authentication_success`
* for the event `signer_authentication_failure`

**Example** (`Example 1`)

```json
{
  "document_history": [
    {
      "email": "johndoe@email.com",
      "event": "create_document",
      "origin": "original",
      "created": 1622029581,
      "user_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "field_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "unique_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "element_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "ip_address": "1X.XX.XX.XX",
      "document_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "client_app_name": "Sample Application",
      "json_attributes": "{\"some\":\"data\"}",
      "client_timestamp": 1622029581
    }
  ],
  "email_history_events": [
    {
      "created": 1622029581,
      "message": "Some message",
      "subject": "Some subject",
      "event_type": "document_created",
      "json_attributes": "{\"some\":\"data\"}"
    }
  ]
}
```

**Example** (`with email history events`)

```json
{
  "document_history": [
    {
      "email": "johndoe@email.com",
      "event": "create_document",
      "origin": "original",
      "created": 1622029581,
      "user_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "field_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "unique_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "element_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "ip_address": "1X.XX.XX.XX",
      "document_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
      "client_app_name": "Sample Application",
      "json_attributes": "{\"some\":\"data\"}",
      "client_timestamp": 1622029581
    }
  ],
  "email_history_events": [
    {
      "created": 1622029581,
      "message": "Some message",
      "subject": "Some subject",
      "event_type": "document_created",
      "json_attributes": "{\"some\":\"data\"}"
    }
  ]
}
```

**Example** (`without email history events`)

```json
{
  "email": "johndoe@email.com",
  "event": "created_document",
  "origin": "original",
  "created": 1622029581,
  "user_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
  "field_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
  "unique_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
  "element_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
  "ip_address": "1X.XX.XX.XX",
  "document_id": "ddXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
  "client_app_name": "Sample Application",
  "json_attributes": "{\"some\":\"data\"}",
  "client_timestamp": 1622029581
}
```

**Example** (`for the event `signer_authentication_failure``)

```json
[
  {
    "email": "owner_document@email.com",
    "event": "created_document",
    "origin": "original",
    "created": 1672751407,
    "user_id": "35XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "02XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "5X.XX.XX.XX",
    "document_id": "01XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample application",
    "json_attributes": null,
    "client_timestamp": null
  },
  {
    "email": "owner_document@email.com",
    "event": "document_signing_session_completed",
    "created": 1672751421,
    "user_id": "35XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "3eXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "5X.XX.XX.XX",
    "document_id": "01XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample application",
    "json_attributes": null,
    "client_timestamp": 1672751421
  },
  {
    "email": "owner_document@email.com",
    "event": "document_invite_sent",
    "created": 1672751636,
    "user_id": "35XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "93XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "5X.XX.XX.XX",
    "document_id": "01XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample application",
    "json_attributes": {
      "signers": [
        "signer1@email.com",
        "signer2@email.com"
      ],
      "viewers": []
    },
    "client_timestamp": null
  },
  {
    "email": "signer1@email.com",
    "event": "signer_authentication_failure",
    "created": 1672751775,
    "user_id": "6aXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "73XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "5X.XX.XX.XX",
    "document_id": "01XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample Application",
    "json_attributes": {
      "phone_number_2fa": "+1XXX-XXXXXXX",
      "authentication_type": "sms"
    },
    "client_timestamp": 1672751775
  },
  {
    "email": "signer2@email.com",
    "event": "signer_authentication_failure",
    "created": 1672751811,
    "user_id": "83XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "14XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "5X.XX.XX.XX",
    "document_id": "01XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample Application",
    "json_attributes": {
      "phone_number_2fa": "+1XXX-XXXXXXX",
      "authentication_type": "phone_call"
    },
    "client_timestamp": 1672751811
  }
]
```

**Example** (`for the event `signer_authentication_success``)

```json
[
  {
    "email": "document_owner@email.com",
    "event": "created_document",
    "origin": "original",
    "created": "1672128416",
    "user_id": "35XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "f3XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "35.263.222.70",
    "document_id": "bbXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample application",
    "json_attributes": null,
    "client_timestamp": null
  },
  {
    "email": "owner_document@email.com",
    "event": "document_signing_session_completed",
    "created": "1672128418",
    "user_id": "35XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "b1XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "35.263.222.70",
    "document_id": "bbXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample application",
    "json_attributes": null,
    "client_timestamp": "1672128418"
  },
  {
    "email": "owner_document1@email.com",
    "event": "document_invite_sent",
    "created": "1672128439",
    "user_id": "35XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "ceXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "35.263.222.70",
    "document_id": "bbXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample application",
    "json_attributes": {
      "signers": [
        "signer1@email.com",
        "signer2@email.com"
      ],
      "viewers": []
    },
    "client_timestamp": null
  },
  {
    "email": "signer1@email.com",
    "event": "signer_authentication_success",
    "created": "1672128445",
    "user_id": "6aXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "6dXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "35.263.222.70",
    "document_id": "bbXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Signer Application",
    "json_attributes": {
      "phone_number_2fa": "+1XXX-XXXXXXX",
      "authentication_code": "57329",
      "authentication_type": "sms"
    },
    "client_timestamp": "1672128445"
  },
  {
    "email": "owner_document@email.com",
    "event": "document_invite_sent",
    "created": "1672128446",
    "user_id": "35XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "00XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "3X.XX.XX.XX",
    "document_id": "bbXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample Application",
    "json_attributes": {
      "signers": [
        "signer2@email.com"
      ],
      "viewers": []
    },
    "client_timestamp": null
  },
  {
    "email": "signer1@email.com",
    "event": "added_signature",
    "created": "1672128446",
    "user_id": "6aXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": "6bXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "unique_id": "40XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": "79XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "ip_address": "3X.XX.XX.XX",
    "document_id": "bbXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample Application",
    "json_attributes": null,
    "client_timestamp": "1672128446"
  },
  {
    "email": "signer2@email.com",
    "event": "signer_authentication_success",
    "created": "1672128452",
    "user_id": "83XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": null,
    "unique_id": "acXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": null,
    "ip_address": "3X.XX.XX.XX",
    "document_id": "bbXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample Application",
    "json_attributes": {
      "phone_number_2fa": "+1XXX-XXXXXXX",
      "authentication_type": "phone_call"
    },
    "client_timestamp": "1672128452"
  },
  {
    "email": "signer2@email.com",
    "event": "added_signature",
    "created": "1672128453",
    "user_id": "83XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "field_id": "f5XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "unique_id": "0eXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "element_id": "10XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "ip_address": "3X.XX.XX.XX",
    "document_id": "bbXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    "client_app_name": "Sample Application",
    "json_attributes": null,
    "client_timestamp": "1672128453"
  }
]
```

### 400

- Request with any of cases:

* invalid token 
* expired token 
* empty header
* authorization = null
* authorization without value

	
- User does not have access to this document

**Example** (`Invalid token`)

```json
{
  "code": 1537,
  "message": "invalid_token"
}
```

**Example** (`No access to this document`)

```json
{
  "code": 65610,
  "message": "not readable"
}
```

## Code Examples

> Replace `$SIGNNOW_ACCESS_TOKEN` and any `{placeholder}` values before running.

### cURL

```bash
curl -X GET \
  "https://api.signnow.com/document/{document_id}/historyfull" \
  -H "Authorization: Bearer $SIGNNOW_ACCESS_TOKEN"
```

---
*Full reference: https://docs.signnow.com/docs/document/operations/get-document-historyfull*
